SystemOrganization addCategory: #GODEmail!

Object subclass: #GODMail
	instanceVariableNames: 'hostname password user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODEmail'!

!GODMail class methodsFor: 'instance creation' stamp: 'gfg 10/3/2014 19:51'!
connectTo: hostname identifiedAs: user password: password
	^(((self new hostname: hostname) user: user) password: password)! !

!GODMail methodsFor: 'accessing' stamp: 'gfg 10/3/2014 19:51'!
hostname
	^hostname! !

!GODMail methodsFor: 'accessing' stamp: 'gfg 10/3/2014 19:51'!
hostname: aString
	hostname := aString! !

!GODMail methodsFor: 'initialize-release' stamp: 'gfg 10/3/2014 19:51'!
initialize
	self initializeConnectionInfo.! !

!GODMail methodsFor: 'initialize-release' stamp: 'gfg 10/3/2014 19:51'!
initializeConnectionInfo
	hostname := ''.
	user := ''.
	password := ''.! !

!GODMail methodsFor: 'accessing' stamp: 'gfg 10/3/2014 19:51'!
password: aString
	password := aString! !

!GODMail methodsFor: 'accessing' stamp: 'gfg 10/3/2014 19:51'!
user
	^user! !

!GODMail methodsFor: 'accessing' stamp: 'gfg 10/3/2014 19:51'!
user: aString
	user := aString! !

!GODMail methodsFor: 'private' stamp: 'gfg 10/3/2014 19:51'!
validateConnectionInfo
	hostname isEmpty
		ifTrue: [^Error signal: 'Hostname value is empty'].

	user isEmpty
		ifTrue: [^Error signal: 'User value is empty'].
	
	password isEmpty
		ifTrue: [^Error signal: 'Password value is empty'].! !

GODMail subclass: #GODMailReceiver
	instanceVariableNames: 'client messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODEmail'!

!GODMailReceiver methodsFor: 'actions' stamp: 'RF 10/14/2014 17:14'!
receive
"Connects to the server, receives new emails and converts them into a list of GodData"
self validateConnectionInfo.
client := POP3Client openOnHostNamed: hostname.
"The below part of the code is yet to be tested"
[
client loginUser: user password: password.
client logProgressToTranscript.

messages := OrderedCollection new.
1 to: client messageCount do: [ :messageNr |
messages add: (client retrieveMessage: messageNr) ]]
ensure: [client close].

^messages.! !

GODMail subclass: #GODMailSender
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODEmail'!

!GODMailSender methodsFor: 'actions' stamp: 'LFSA 9/28/2014 15:36'!
send: data to: recipient
	"Sends the GODData contained in data to recipient (a string with an email address)"
	self validateConnectionInfo.
	^true.! !
